/* eslint-env node */
const path = require('path');
const fetchRecorder = require('fetch-recorder');

function initFetchRecorder(files, proxies, karmaPort, karmaProtocol, fetchRecorderOptions) {
    const fetchRecorderPath = path.dirname(require.resolve('fetch-recorder'));
    const karmaFetchRecorderPath = path.dirname(require.resolve('karma-fetch-recorder'));
    fetchRecorderOptions.clientOrigin = `${karmaProtocol}//localhost:${karmaPort}`;
    fetchRecorder.server.run(fetchRecorderOptions);
    files.unshift({
        pattern: path.join(fetchRecorder.browser.generateScript()),
        inculded: true,
        served: true,
        watched: false
    });
    files.unshift({
        pattern: path.join(fetchRecorderPath, 'fetchRecorder_serviceWorker.js'),
        included: false,
        served: true,
        watched: false
    });
    files.unshift({
        pattern: path.join(karmaFetchRecorderPath, 'serviceWorkerHook.js'),
        included: true,
        served: true,
        watched: false
    });
    proxies['/fetchRecorder_serviceWorker.js'] = '/base/node_modules/fetch-recorder/fetchRecorder_serviceWorker.js';
}

initFetchRecorder.$inject = [ 'config.files', 'config.proxies', 'config.port', 'config.protocol', 'config.fetchRecorderOptions' ];

module.exports = {
    'framework:fetch-recorder': [ 'factory', initFetchRecorder ]
};
